searchNodes=[{"ref":"SmartCity.Event.html","title":"SmartCity.Event","type":"module","doc":"Defines macros for encoding event types the Smart City platform will respond to in any of the various micro service components in a central location shared by all components."},{"ref":"SmartCity.Event.html#dataset_update/0","title":"SmartCity.Event.dataset_update/0","type":"macro","doc":"Defines an update event to a dataset within the system. The system treats create events as a subset of updates."},{"ref":"SmartCity.Event.html#file_upload/0","title":"SmartCity.Event.file_upload/0","type":"macro","doc":"Signals that a new file has been uploaded to the object store and made available for the rest of the system."},{"ref":"SmartCity.Event.html#organization_update/0","title":"SmartCity.Event.organization_update/0","type":"macro","doc":"Defines an update event to an organization within the system. The system treats create events as a subset of updates."},{"ref":"SmartCity.Event.BaseEvent.html","title":"SmartCity.Event.BaseEvent","type":"module","doc":"This module provides deserialization and atomization for event structs"},{"ref":"SmartCity.Event.BaseEvent.html#new/1","title":"SmartCity.Event.BaseEvent.new/1","type":"function","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.html","title":"SmartCity.Event.DatasetUpdate","type":"module","doc":"Struct defining a dataset update event. This is triggered when new datasets are put into the system or existing datasets are updated const Dataset = { &quot;id&quot;: &quot;&quot;, // UUID &quot;business&quot;: { // Project Open Data Metadata Schema v1.1 &quot;categories&quot;: [&quot;&quot;], &quot;conformsToUri&quot;: &quot;&quot;, &quot;contactEmail&quot;: &quot;&quot;, &quot;contactName&quot;: &quot;&quot;, &quot;dataTitle&quot;: &quot;&quot;, // user friendly (dataTitle) &quot;describedByMimeType&quot;: &quot;&quot;, &quot;describedByUrl&quot;: &quot;&quot;, &quot;description&quot;: &quot;&quot;, &quot;homepage&quot;: &quot;&quot;, &quot;issuedDate&quot;: &quot;&quot;, &quot;keywords&quot;: [&quot;&quot;], &quot;language&quot;: &quot;&quot;, &quot;license&quot;: &quot;&quot;, &quot;modifiedDate&quot;: &quot;&quot;, &quot;orgTitle&quot;: &quot;&quot;, // user friendly (orgTitle) &quot;parentDataset&quot;: &quot;&quot;, &quot;publishFrequency&quot;: &quot;&quot;, &quot;referenceUrls&quot;: [&quot;&quot;], &quot;rights&quot;: &quot;&quot;, &quot;spatial&quot;: &quot;&quot;, &quot;temporal&quot;: &quot;&quot; }, &quot;technical&quot;: { &quot;authHeaders&quot;: {&quot;header1&quot;: &quot;&quot;, &quot;header2&quot;: &quot;&quot;} &quot;authUrl&quot;: &quot;&quot;, &quot;cadence&quot;: &quot;&quot;, &quot;dataName&quot;: &quot;&quot;, // ~r/[a-zA-Z_]+$/ &quot;orgId&quot;: &quot;&quot;, &quot;orgName&quot;: &quot;&quot;, // ~r/[a-zA-Z_]+$/ &quot;protocol&quot;: &quot;&quot;, // List of protocols to use. Defaults to nil. Can be [http1, http2] &quot;schema&quot;: [{ &quot;name&quot;: &quot;&quot;, &quot;type&quot;: &quot;&quot;, &quot;description&quot;: &quot;&quot; }], &quot;sourceFormat&quot;: &quot;&quot;, &quot;sourceHeaders&quot;: { &quot;header1&quot;: &quot;&quot;, &quot;header2&quot;: &quot;&quot; }, &quot;sourceQueryParams&quot;: { &quot;key1&quot;: &quot;&quot;, &quot;key2&quot;: &quot;&quot; }, &quot;sourceType&quot;: &quot;&quot;, // remote|stream|ingest|host &quot;sourceUrl&quot;: &quot;&quot;, &quot;systemName&quot;: &quot;&quot;, // ${orgName}__${dataName}, &quot;transformations&quot;: [], // ? &quot;validations&quot;: [], // ? }, &quot;_metadata&quot;: { &quot;intendedUse&quot;: [], &quot;expectedBenefit&quot;: [] } }"},{"ref":"SmartCity.Event.DatasetUpdate.html#is_host?/1","title":"SmartCity.Event.DatasetUpdate.is_host?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is host"},{"ref":"SmartCity.Event.DatasetUpdate.html#is_ingest?/1","title":"SmartCity.Event.DatasetUpdate.is_ingest?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is ingest"},{"ref":"SmartCity.Event.DatasetUpdate.html#is_remote?/1","title":"SmartCity.Event.DatasetUpdate.is_remote?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is remote"},{"ref":"SmartCity.Event.DatasetUpdate.html#is_stream?/1","title":"SmartCity.Event.DatasetUpdate.is_stream?/1","type":"function","doc":"Returns true if SmartCity.Dataset.Technical sourceType field is stream"},{"ref":"SmartCity.Event.DatasetUpdate.html#new/1","title":"SmartCity.Event.DatasetUpdate.new/1","type":"function","doc":"Returns a new SmartCity.Event.DatasetUpdate struct. SmartCity.Event.DatasetUpdate.Business, SmartCity.Event.DatasetUpdate.Technical, and SmartCity.Event.DatasetUpdate.Metadata structs will be created along the way. Parameters msg : map defining values of the struct to be created. Can be initialized by map with string keys map with atom keys JSON"},{"ref":"SmartCity.Event.DatasetUpdate.html#t:id/0","title":"SmartCity.Event.DatasetUpdate.id/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.html#t:t/0","title":"SmartCity.Event.DatasetUpdate.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Business.html","title":"SmartCity.Event.DatasetUpdate.Business","type":"module","doc":"A struct representing the business data portion of a dataset update struct definition (represented by SmartCity.Event.DatasetUpdate) You probably won&#39;t need to access this module directly; SmartCity.Event.DatasetUpdate.new/1 will build this for you"},{"ref":"SmartCity.Event.DatasetUpdate.Business.html#new/1","title":"SmartCity.Event.DatasetUpdate.Business.new/1","type":"function","doc":"Returns a new SmartCity.Event.DatasetUpdate.Business struct. Can be created from Map with string or atom keys. Parameters msg: Map with string or atom keys that defines the dataset&#39;s business metadata. See SmartCity.Event.DatasetUpdate.Business typespec for available keys. Required Keys dataTitle description modifiedDate orgTitle contactName contactEmail License will default to http://opendefinition.org/licenses/cc-by/ if not provided"},{"ref":"SmartCity.Event.DatasetUpdate.Business.html#t:license_or_default/0","title":"SmartCity.Event.DatasetUpdate.Business.license_or_default/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Business.html#t:not_required/0","title":"SmartCity.Event.DatasetUpdate.Business.not_required/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Business.html#t:t/0","title":"SmartCity.Event.DatasetUpdate.Business.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Metadata.html","title":"SmartCity.Event.DatasetUpdate.Metadata","type":"module","doc":"A struct defining internal metadata on a dataset update event message."},{"ref":"SmartCity.Event.DatasetUpdate.Metadata.html#new/1","title":"SmartCity.Event.DatasetUpdate.Metadata.new/1","type":"function","doc":"Returns a new SmartCity.Event.DatasetUpdate.Metadata struct. Can be created from Map with string or atom keys. Raises an ArgumentError when passed invalid input. Parameters msg: Map with string or atom keys that defines the dataset&#39;s metadata. Examples iex&gt; SmartCity.Event.DatasetUpdate.Metadata.new(%{&quot;intendedUse&quot; =&gt; [&quot;a&quot;,&quot;b&quot;,&quot;c&quot;], &quot;expectedBenefit&quot; =&gt; [1,2,3]}) %SmartCity.Event.DatasetUpdate.Metadata{ expectedBenefit: [1, 2, 3], intendedUse: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;] } iex&gt; SmartCity.Event.DatasetUpdate.Metadata.new(%{:intendedUse =&gt; [&quot;a&quot;,&quot;b&quot;,&quot;c&quot;], :expectedBenefit =&gt; [1,2,3]}) %SmartCity.Event.DatasetUpdate.Metadata{ expectedBenefit: [1, 2, 3], intendedUse: [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;] } iex&gt; SmartCity.Event.DatasetUpdate.Metadata.new(&quot;Not a map&quot;) ** (ArgumentError) Invalid internal metadata: &quot;Not a map&quot;"},{"ref":"SmartCity.Event.DatasetUpdate.Metadata.html#t:t/0","title":"SmartCity.Event.DatasetUpdate.Metadata.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Technical.html","title":"SmartCity.Event.DatasetUpdate.Technical","type":"module","doc":"A struct defining technical metadata on a dataset update event message."},{"ref":"SmartCity.Event.DatasetUpdate.Technical.html#new/1","title":"SmartCity.Event.DatasetUpdate.Technical.new/1","type":"function","doc":"Returns a new SmartCity.Event.DatasetUpdate.Technical. Can be created from Map with string or atom keys. Raises an ArgumentError when passed invalid input Parameters msg: Map with string or atom keys that defines the dataset&#39;s technical metadata Required Keys dataName orgName systemName sourceUrl sourceFormat sourceType will default to &quot;remote&quot; cadence will default to &quot;never&quot;"},{"ref":"SmartCity.Event.DatasetUpdate.Technical.html#t:not_required/1","title":"SmartCity.Event.DatasetUpdate.Technical.not_required/1","type":"type","doc":""},{"ref":"SmartCity.Event.DatasetUpdate.Technical.html#t:t/0","title":"SmartCity.Event.DatasetUpdate.Technical.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html","title":"SmartCity.Event.FileUpload","type":"module","doc":"Defines the information needed to process uploaded files by components of the system including the files&#39; type, parent identifier, and location info."},{"ref":"SmartCity.Event.FileUpload.html#new/1","title":"SmartCity.Event.FileUpload.new/1","type":"function","doc":"Instantiates an instance of a file upload event struct."},{"ref":"SmartCity.Event.FileUpload.html#type/1","title":"SmartCity.Event.FileUpload.type/1","type":"function","doc":"Standardize file type definitions by deferring to the official media type of the file based on a supplied extension."},{"ref":"SmartCity.Event.FileUpload.html#t:bucket/0","title":"SmartCity.Event.FileUpload.bucket/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html#t:extension/0","title":"SmartCity.Event.FileUpload.extension/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html#t:id/0","title":"SmartCity.Event.FileUpload.id/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html#t:key/0","title":"SmartCity.Event.FileUpload.key/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html#t:mime_type/0","title":"SmartCity.Event.FileUpload.mime_type/0","type":"type","doc":""},{"ref":"SmartCity.Event.FileUpload.html#t:t/0","title":"SmartCity.Event.FileUpload.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.OrganizationUpdate.html","title":"SmartCity.Event.OrganizationUpdate","type":"module","doc":"Struct defining an organization update event. const Organization = { &quot;description&quot;: &quot;&quot;, &quot;dn&quot;: &quot;&quot;, // LDAP distinguished name &quot;homepage&quot;: &quot;&quot;, &quot;id&quot;: &quot;&quot;, // uuid &quot;logoUrl&quot;: &quot;&quot;, &quot;orgName&quot;: &quot;&quot;, // system friendly &quot;orgTitle&quot;: &quot;&quot; // user friendly }"},{"ref":"SmartCity.Event.OrganizationUpdate.html#new/1","title":"SmartCity.Event.OrganizationUpdate.new/1","type":"function","doc":"Returns a new SmartCity.Event.OrganizationUpdate struct. Can be created from: map with string keys map with atom keys JSON"},{"ref":"SmartCity.Event.OrganizationUpdate.html#t:id/0","title":"SmartCity.Event.OrganizationUpdate.id/0","type":"type","doc":""},{"ref":"SmartCity.Event.OrganizationUpdate.html#t:reason/0","title":"SmartCity.Event.OrganizationUpdate.reason/0","type":"type","doc":""},{"ref":"SmartCity.Event.OrganizationUpdate.html#t:t/0","title":"SmartCity.Event.OrganizationUpdate.t/0","type":"type","doc":""},{"ref":"SmartCity.Event.OrganizationUpdate.NotFound.html","title":"SmartCity.Event.OrganizationUpdate.NotFound","type":"exception","doc":""},{"ref":"SmartCity.Helpers.html","title":"SmartCity.Helpers","type":"module","doc":"Functions used across SmartCity modules."},{"ref":"SmartCity.Helpers.html#deep_merge/2","title":"SmartCity.Helpers.deep_merge/2","type":"function","doc":"Merges two maps into one, including sub maps. Matching keys from the right map will override their corresponding key in the left map."},{"ref":"SmartCity.Helpers.html#to_atom_keys/1","title":"SmartCity.Helpers.to_atom_keys/1","type":"function","doc":"Convert a map with string keys to one with atom keys. Will convert keys nested in a sub-map or a map that is part of a list. Ignores atom keys. Examples iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;abc&quot; =&gt; 123}) %{abc: 123} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;c&quot;}}) %{a: %{b: &quot;c&quot;}} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; [%{&quot;b&quot; =&gt; &quot;c&quot;}]}) %{a: [%{b: &quot;c&quot;}]}"},{"ref":"readme.html","title":"SmartCity","type":"extras","doc":"SmartCity This library defines helper functions that are used across SmartCity modules."},{"ref":"readme.html#installation","title":"SmartCity - Installation","type":"extras","doc":"def deps do [ {:smart_city, &quot;~&gt; 2.4.1&quot;} ] end"},{"ref":"readme.html#basic-usage","title":"SmartCity - Basic Usage","type":"extras","doc":"iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; 1, &quot;b&quot; =&gt; 2, &quot;c&quot; =&gt; 3}) %{a: 1, b: 2, c: 3} iex&gt; SmartCity.Helpers.to_atom_keys(%{&quot;a&quot; =&gt; %{&quot;b&quot; =&gt; &quot;c&quot;}}) %{a: %{b: &quot;c&quot;}} iex&gt; SmartCity.Helpers.deep_merge(%{a: 1, b: 2}, %{a: 3, c: 4}) %{a: 3, b: 2, c: 4} Full documentation can be found at https://hexdocs.pm/smart_city/api-reference.html."},{"ref":"readme.html#contributing","title":"SmartCity - Contributing","type":"extras","doc":"The build process runs these commands: mix local.rebar --force mix local.hex --force mix deps.get mix format --check-formatted mix credo mix test"},{"ref":"readme.html#license","title":"SmartCity - License","type":"extras","doc":"SmartCity is released under the Apache 2.0 license - see the license at http://www.apache.org/licenses/LICENSE-2.0"}]